/********************************************************************************************
* MOD-NAME      : TomAssert.cpp
* LONG-NAME     : Additional assert support during for a the CTom object program.
* DERIVED FROM	: 
*
* AUTHOR        : Dipl.-Ing. Dr. Thomas Fleck
* COPYRIGHT     : 2003 Thomas Fleck
* CREATION-DATE : 08.11.2003
* SP-NO         : 
* FUNCTION      : Additional assert IsDynamic (checks if pointer is local or dynamic)
*                 
* 
*********************************************************************************************/

#include <malloc.h>
#include <stdio.h>

#ifdef _DEBUG

bool IsDynamic(void* pPointer) 
{
   _HEAPINFO hinfo;
   int heapstatus;
   hinfo._pentry = NULL;
   heapstatus = _heapwalk( &hinfo );
   if (heapstatus == _HEAPEMPTY) return false; // no dynamic data allocated

   // hinfo._pentry points to the first heap element.
   // In Visual C++ 5.0 the stack memory lies below the heap memory.
   if (pPointer < hinfo._pentry) return false;
   return true;
}

#endif